/*
 * FreeModbus Libary: LPC214X Port
 * Copyright (C) 2007 Tiago Prado Lone <tiago@maxwellbohr.com.br>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * File: $Id: porttimer.c,v 1.1 2007/04/24 23:15:18 wolti Exp $
 */

/* ----------------------- Platform includes --------------------------------*/
#include "M451Series.h"
#include "port.h"

/* ----------------------- Modbus includes ----------------------------------*/
#include "mb.h"
#include "mbport.h"



/* ----------------------- Start implementation -----------------------------*/
BOOL
xMBPortTimersInit( USHORT usTim1Timerout50us )
{
	  TIMER0 ->CTL = TIMER_PERIODIC_MODE;
    TIMER_SET_CMP_VALUE(TIMER0 , usTim1Timerout50us*12*50);	
    TIMER_EnableInt(TIMER0);  
	  NVIC_EnableIRQ(TMR0_IRQn);
    return TRUE;
}


void
vMBPortTimersEnable(  )
{
		TIMER_Start(TIMER0);	
}

void
vMBPortTimersDisable(  )
{
	TIMER_Stop(TIMER0);
}

void TMR0_IRQHandler( void )
{
   TIMER_ClearIntFlag(TIMER0);
	 ( void )pxMBPortCBTimerExpired(  );
}
